#include "ZBFGApplication.h"

//globals
char *file_buffer;
char *filename;
char *search_string;

MATCH *match_list[10000];
int num_items_in_list = 0;

//BeOS related globals
ZFilePanel	*glob_filepanel;
BPath 		 selected_path("/boot/develop/headers");
bool		zbfg_subdirectory_flag = true;
bool		zbfg_ignore_case_flag = true;
bool		search_in_progress_flag = false;

//==========================
ZApplication::ZApplication()
    : BApplication("application/x-vnd.ZS-SkeletonApp")
{
    BRect	aRect;
   	
	//alocate memory
	file_buffer = new char [FILEBUFFER_SIZE]; 		// File Buffer
	filename = new char [FILENAME_SIZE];
	search_string = new char [SEARCH_STRING_SIZE];
	//MATCH *match_list = new MATCH [10000]; 
	if (file_buffer == NULL || filename == NULL || search_string == NULL || match_list == NULL) {
		BAlert *alert = new BAlert("Error", "Not enough memory", "Damn");
		alert->Go();
		PostMessage(B_QUIT_REQUESTED);
	}
        
    //listview window
	aRect.Set(400, 100, 800, 400);
	listwindow = new ZListWindow(aRect);
		
	//create control window
	aRect.Set(20, 230, 330, 400);
	fZWindowControl = new ZWindowControl(aRect);
	fZWindowControl->Show();
	
	//file open window
	glob_filepanel = new ZFilePanel();
}

//===========================
ZApplication::~ZApplication()
{
	//release memory
	delete [] file_buffer;
	delete [] filename;
	delete [] search_string;
	
	delete_list();
}

//==============================================
void ZApplication::RefsReceived(BMessage *message)
{
	uint32 type; 
	int32 count;
	entry_ref ref;
	BPath path;

	message->GetInfo("refs", &type, &count); 
	if ( type != B_REF_TYPE ) return; //sanity check
	if ( message->FindRef("refs", 0, &ref) == B_OK ) { 
		BEntry entry(&ref, true);
		if ( entry.IsDirectory() && entry.GetPath(&path)==B_OK)
		{
			selected_path = path;
			fZWindowControl->PostMessage(DIRECTORY_CHOSEN_MSG);
		}
	}
}


//==========
int  main()
{	
	ZApplication   *bfgApp = new ZApplication();;
	
    bfgApp->Run();
	
	delete(bfgApp);
	return(0);
}