// Header file for BFG Application, written by Zenja Solaja, July 2000

#ifndef __ZBFGApplication
#define __ZBFGApplication

#include <AppKit.h>
#include <InterfaceKit.h>
#include <StorageKit.h>

#include "ZBFGListStorage.h"
//#include "ZBFGWindow.h"
#include "ZBFGControl.h"
#include "ZBFGFileAccess.h"
#include "ZBFGSearch.h"
#include "ZBFGScrollWindow.h"


#define FILEBUFFER_SIZE		65535
#define FILENAME_SIZE		255
#define SEARCH_STRING_SIZE	255

//====================
//	Class definitions
//====================
class ZApplication : public BApplication {
	public:
    	ZApplication();
    	~ZApplication();
    	virtual void RefsReceived(BMessage *);
		ZWindowControl	*fZWindowControl;
};

//external variables
extern char *file_buffer;
extern char *filename;
extern char *search_string;

extern MATCH *match_list[];
extern int num_items_in_list;

extern ZFilePanel	*glob_filepanel;
extern BPath		selected_path;
extern bool			zbfg_subdirectory_flag;
extern bool			zbfg_ignore_case_flag;
extern bool			search_in_progress_flag;

#endif //__ZBFGApplication