#include "ZBFGApplication.h"
#include <iostream>
#include <AppKit.h>
#include <StorageKit.h>

ZListWindow	*listwindow;
BScrollView *fscrollview;
		
//=============================
ZListWindow::ZListWindow(BRect frame)
	: BWindow(frame, "Search Result", B_DOCUMENT_WINDOW, B_NOT_ZOOMABLE | B_NOT_CLOSABLE | B_WILL_ACCEPT_FIRST_CLICK)
{
	BRect aRect(0, 0, frame.Width()-B_V_SCROLL_BAR_WIDTH, frame.Height());
	//flistview = new BListView(aRect, "ZBFGListView", B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_NAVIGABLE|B_FRAME_EVENTS);
	flistview = new BOutlineListView(aRect, "ZBFGListView", B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_NAVIGABLE|B_FRAME_EVENTS);
	
	flistview->SetInvocationMessage(new BMessage(ITEM_SELECTED_MSG));
	fscrollview = new BScrollView("ZBFGMatchList", flistview, B_FOLLOW_ALL_SIDES, 0, false, true, B_FANCY_BORDER);
	AddChild(fscrollview);
	Show();
}

/* When updating scroll view, its necessary to lock the window - otherwise, say 'Hello' to Mr.bdb */

//============================
void ZListWindow::AddItem(BStringItem *item)
{
	flistview->LockLooper(); 
	flistview->AddItem(item);
	flistview->UnlockLooper(); 
}

//============================
void ZListWindow::AddUnder(BStringItem *item, BStringItem *super_item)
{
	flistview->LockLooper(); 
	flistview->AddUnder(item, super_item);
	flistview->UnlockLooper(); 
}

//============================
void ZListWindow::RemoveItem(int item)
{
	flistview->LockLooper(); 
	flistview->RemoveItem(item);
	flistview->UnlockLooper(); 
}

//============================
int32 ZListWindow::CountItems(void)
{
	int32 count;
	flistview->LockLooper(); 
	count = flistview->CountItems();
	flistview->UnlockLooper();
	return count; 
}

//============================
void ZListWindow::EmptyList()
{
	flistview->LockLooper(); 
	flistview->MakeEmpty();
	flistview->UnlockLooper(); 
}

//============================
void ZListWindow::MessageReceived(BMessage *message)
{
	switch(message->what){
		case ITEM_SELECTED_MSG:
		{
			//Find SuperItem (either chosen or one level down) and launch
			BListItem *sItem;	
			int32 selected = flistview->CurrentSelection(0);
			if (selected >= 0)
			{
				sItem = flistview->Superitem(flistview->ItemAt(selected));
				if (sItem == NULL)
					sItem = flistview->ItemAt(selected);
			
				entry_ref ref;
				BEntry entry(match_list[flistview->IndexOf(sItem)]->contents);
				entry.GetRef(&ref);
				be_roster->Launch(&ref, NULL, NULL);
			}
			break;
		}
		default:
			BWindow::MessageReceived(message);
	}
}

